From 490fdcf1fdd51ba21e454f0a0a0e8fac3c9e526f Mon Sep 17 00:00:00 2001
From: root <root@pgvm.rlsumirojk0etd4qpjbaa2afce.tx.internal.cloudapp.net>
Date: Wed, 12 Apr 2023 22:25:03 +0000
Subject: [PATCH] Add ps display while waiting for wal

---
 src/backend/access/transam/xlogutils.c | 8 +++++++-
 1 file changed, 7 insertions(+), 1 deletion(-)

diff --git a/src/backend/access/transam/xlogutils.c b/src/backend/access/transam/xlogutils.c
index e174a2a891..c10e2c9e07 100644
--- a/src/backend/access/transam/xlogutils.c
+++ b/src/backend/access/transam/xlogutils.c
@@ -31,7 +31,7 @@
 #include "utils/guc.h"
 #include "utils/hsearch.h"
 #include "utils/rel.h"
-
+#include "utils/ps_status.h"
 
 /* GUC variable */
 bool		ignore_invalid_pages = false;
@@ -957,6 +957,10 @@ read_local_xlog_page_guts(XLogReaderState *state, XLogRecPtr targetPagePtr,
 				break;
 			}
 
+			char		activitymsg[128];
+			snprintf(activitymsg, sizeof(activitymsg), "waiting for xlog to be available");
+			set_ps_display(activitymsg);
+
 			CHECK_FOR_INTERRUPTS();
 			pg_usleep(1000L);
 		}
@@ -987,6 +991,8 @@ read_local_xlog_page_guts(XLogReaderState *state, XLogRecPtr targetPagePtr,
 		}
 	}
 
+	set_ps_display("");
+
 	if (targetPagePtr + XLOG_BLCKSZ <= read_upto)
 	{
 		/*
-- 
2.25.1

